
typedef struct _memory_t {
	// memory size used
	int used;
	// memory size left
	int left;

	// internal memory pointer
	void *_mem;
} memory_t;

// yes, there is no `free' memory API, I'm lazy.
void memory_init(memory_t *mem, int maxsize);
void *memory_get(memory_t *mem, int size);
void memory_status(memory_t *mem, int *used, int *left);
void memory_destroy(memory_t *mem);
