#include <stdio.h>
#include "mem.h"
#include "obf.h"

int main(void)
{
	memory_t mem;
	memory_init(&mem, 1000);
	void *a = memory_get(&mem, 10);
	void *b = memory_get(&mem, 20);

	// do something with `a' and `b'

	// get the status (and compare it with
	// the "encrypted" status)
	int used, left;
	memory_status(&mem, &used, &left);
	printf("Real status: %d %d\n", used, left);
	printf("Encrypted status: %d, %d\n",
		mem.used, mem.left);

	memory_destroy(&mem);
}
